'*******************************************************************************
Function SeeMessageBox(rMessageBox As String, rTitleMsgBox As String)Export As Long
'visualizza il MsgBox
'IN:rMessageBox$:messaggio da visualizzare
'IN:rTitleMsgBox$:caption del messaggio da visualizzare

MsgBox rMessageBox$,,rTitleMsgBox$


End Function

'*******************************************************************************
Function WindoAttention(rOnWinAtt As String , rCaptionWinAtt As String) Export As LONG
'visualizza la WindowAttention
'IN:rOnWinAtt$:da visualizzare sulla WinAttention
'IN:rCaptionWinAtt$:visualizza sul caption: "error" or "wait"
'OUT:mFunctRes&:0=error od non generata la WinAttention; 0 <> handle dialog

LOcal mFunctRes As LONG'0=error od non generata la WinAttention; 0 <> handle dialog
LOcal mLargWinAtt As LONG
LOcal mHightWinAtt As LONG
LOcal mXbuttonWinAtt As LONG
LOcal mYbuttonWinAtt As LONG
LOcal mLargButtonWinAtt As LONG
LOcal mHightButtonWinAtt As LONG


mLargWinAtt&=215
mHightWinAtt&=68
mXbuttonWinAtt&=85
mYbuttonWinAtt&=50
mLargButtonWinAtt&=30
mHightButtonWinAtt&=15


Dialog Font gFontName$,gFontSize&
	'gFontName$="MS Sans Serif":tipo di font:default=MS Sans Serif
	'gFontSize&=8'size Font:default 8 point

Dialog New %HWND_DESKTOP, rCaptionWinAtt$, gTabWinAttIns.XLeftUpWinAttIns, gTabWinAttIns.YLeftUpWinAttIns, _
					mLargWinAtt&,mHightWinAtt&, _
			     %WS_POPUP or %Ws_MiniMizeBox OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CAPTION OR _
              %WS_SYSMENU OR %DS_ABSALIGN OR %DS_3DLOOK OR %DS_SETFONT OR _
              %DS_MODALFRAME OR %DS_NOIDLEMSG, _
              %WS_EX_DLGMODALFRAME OR %WS_EX_CONTROLPARENT OR %WS_EX_WINDOWEDGE To gTabWinAttIns.HandleWinAtt

If gTabWinAttIns.HandleWinAtt&=0 Then
	SeeMessageBox("Error to open WinAttention","")
	'visualizza il MsgBox
	'IN:rMessageBox$:messaggio da visualizzare
	'IN:rTitleMsgBox$:caption del messaggio da visualizzare

	mFunctRes&=0'0=error od non creata la dialog; OUT:0 <> handle dialog
Else
	CONTROL ADD BUTTON, gTabWinAttIns.HandleWinAtt, %ButtonContinue, "Continue", mXbuttonWinAtt&-40, _
				mYbuttonWinAtt&, mLargButtonWinAtt&, mHightButtonWinAtt&, %BS_DEFAULT OR %WS_CHILD OR _
				%WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, %WS_EX_NOPARENTNOTIFY

	CONTROL ADD LABEL, gTabWinAttIns.HandleWinAtt,  %IDC_WinAtt, rOnWinAtt$ , 1, 1, 215, 75, _
              %WS_CHILD OR %SS_LEFT Or %WS_VISIBLE OR %WS_GROUP OR %SS_NOPREFIX, _
              %WS_EX_NOPARENTNOTIFY

	CONTROL ADD BUTTON, gTabWinAttIns.HandleWinAtt, %IDC_FlowTable, "Flow Table", mXbuttonWinAtt&+40, _
				mYbuttonWinAtt+4&, mLargButtonWinAtt&+15, mHightButtonWinAtt&-5, %BS_DEFAULT OR %WS_CHILD OR _
				%WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, %WS_EX_NOPARENTNOTIFY

	Dialog Show Modal gTabWinAttIns.HandleWinAtt Call WindoAttentionProc
	mFunctRes&=gTabWinAttIns.HandleWinAtt

End If

Function=mFunctRes&'0=error od non creata la dialog; OUT:0 <> handle dialog

End Function

'*******************************************************************************
CallBack Function WindoAttentionProc() As LONG

Static mFlowInternal As LONG'0=activate TabFlowInternal(); 1=non activate TabFlowInternal()

SELECT CASE CBMSG
CASE %WM_COMMAND
   SELECT CASE CBCTL
   CASE %ButtonContinue
		IF CBCTLMSG = %BN_CLICKED THEN
			DIALOG END CBHNDL, 0
		   gTabWinAttIns.HandleWinAtt=0'handle di WinAttention
		End If
		Function=1
	CASE %IDC_FlowTable
		If CBCTLMSG=%BN_CLICKED	Then
			If mFlowInternal&=0 Then'0=activate TabFlowInternal(); 1=non activate TabFlowInternal()
				mFlowInternal&=1
				TabFlowInternal("Attention")'Function di partenza per visualizzare e modificare gTabFlow()
				mFlowInternal&=0
			End If
		End If
		Function=1
	END SELECT

CASE %WM_CTLCOLORBTN, %WM_CTLCOLOREDIT, %WM_CTLCOLORLISTBOX, %WM_CTLCOLORSTATIC
	IF CBLPARAM = GetDlgItem(CBHNDL, %IDC_WinAtt) THEN
		SetBkColor CBWPARAM, GetSysColor(%COLOR_SCROLLBAR)
      FUNCTION = GetStockObject(%NULL_BRUSH)
      EXIT FUNCTION
   ELSEIF CBLPARAM = GetDlgItem(CBHNDL, %ButtonContinue) THEN
      SetBkColor CBWPARAM, GetSysColor(%COLOR_SCROLLBAR)
      FUNCTION = GetStockObject(%NULL_BRUSH)
      EXIT FUNCTION
   END IF


END SELECT

End Function

'*******************************************************************************
Function WindoFlowAccess() Export As Long
'attiva la finestra FlowAccess per abilitare manualmente la visualizzazione della TabFlow
'che appare al 1 Debugxx successivo.(Default). Se gia' attiva non ha alcun effetto.
'OUT:gTabWinFlowAccess.HndlWinFlowAccess:0 se non creato Dialog FlowAccess
																 '0<> se creata Dialog FlowAccess


Local mLargFlowAccess As Long
Local mHightFlowAccess As Long
Local mXBtnFlowAccess As Long
Local mYBtnFlowAccess As Long
Local mLargBtnFlowAccess As Long
Local mHightBtnFlowAccess As Long

mLargFlowAccess&=100
mHightFlowAccess&=68
mXBtnFlowAccess&=14
mYBtnFlowAccess&=12
mLargBtnFlowAccess&=70
mHightBtnFlowAccess&=15

If gTabWinFlowAccess.HndlWinFlowAccess=0 Then
	Dialog Font gFontName$,gFontSize&
	'gFontName$="MS Sans Serif":tipo di font:default=MS Sans Serif
	'gFontSize&=8'size Font:default 8 point

	Dialog New %HWND_DESKTOP, "Flow Access",,, mLargFlowAccess&,mHightFlowAccess&, _
			     %DS_3DLOOK OR %DS_CENTER Or %DS_MODALFRAME OR %WS_BORDER Or %WS_DLGFRAME Or _
				  %WS_MINIMIZE Or %WS_MINIMIZEBOX OR %WS_VISIBLE OR _
				  %WS_CAPTION OR %WS_SYSMENU OR  %DS_SETFONT OR %DS_NOIDLEMSG, _
              %WS_EX_WINDOWEDGE To gTabWinFlowAccess.HndlWinFlowAccess

	If gTabWinFlowAccess.HndlWinFlowAccess=0 Then
		SeeMessageBox("Error to open WindoFlowAccess","")
		'visualizza il MsgBox
		'IN:rMessageBox$:messaggio da visualizzare
		'IN:rTitleMsgBox$:caption del messaggio da visualizzare

	Else
		CONTROL ADD BUTTON, gTabWinFlowAccess.HndlWinFlowAccess, %IDC_FlowTableWinAccess, "Table Flow", _
					mXBtnFlowAccess&, mYBtnFlowAccess&, mLargBtnFlowAccess&, mHightBtnFlowAccess&, _
					%BS_DEFAULT OR %WS_CHILD OR %WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, _
              %WS_EX_NOPARENTNOTIFY
		CONTROL ADD BUTTON, gTabWinFlowAccess.HndlWinFlowAccess, %IDC_MasterDogFlowAccess, "Master Watch Dog", _
					mXBtnFlowAccess&, _
					mYBtnFlowAccess&+30, mLargBtnFlowAccess&, mHightBtnFlowAccess&, %BS_DEFAULT OR %WS_CHILD _
					OR %WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, %WS_EX_NOPARENTNOTIFY

		Dialog Show Modeless gTabWinFlowAccess.HndlWinFlowAccess Call WindoFlowAccessProc

	End If
End If

End Function

'*******************************************************************************
CallBack Function WindoFlowAccessProc() As LONG

Local mVar As STRING

SELECT CASE CBMSG
CASE %WM_COMMAND
   SELECT CASE CBCTL
   CASE %IDC_FlowTableWinAccess
		If CBCTLMSG=%BN_CLICKED	Then
			gTabWinFlowAccess.StatusFlowTableWinAccess=1'0=non visualizzare FlowTable; 1=visualizza FlowTable
			CloseWindow gTabWinFlowAccess.HndlWinFlowAccess
			Function=1
		End If
	Case %IDC_MasterDogFlowAccess
		If CBCTLMSG=%BN_CLICKED	Then
			mVar$="Now:"+Str$(gTabWinFlowAccess.MaxMasterDog)+$CrLf+"D:disable"+$CrLf+"x>0: new Master Watch Dog"
			mVar$=InputBox$(mVar$,"Master Watch Dog",Str$(gTabWinFlowAccess.MaxMasterDog))
			If UCase$(Left$(Remove$(mVar$," "),1))="D" Then
				gTabWinFlowAccess.MaxMasterDog=-1
				gTabWinFlowAccess.DisabMasterWatchDog=1'0=abilita gCounterMasterDog&; 1=disabilita gCounterMasterDog&
			Elseif Val(mVar$)<0 Then
				gTabWinFlowAccess.MaxMasterDog=-1
				gTabWinFlowAccess.DisabMasterWatchDog=1'0=abilita gCounterMasterDog&; 1=disabilita gCounterMasterDog&
			Elseif Val(mVar$)>0 Then
				gTabWinFlowAccess.MaxMasterDog=Val(mVar$)
			End If
			CloseWindow gTabWinFlowAccess.HndlWinFlowAccess
			If gTabWinVirtList.HandleListView<>0 Then' virtual listview control handle
				SetFocus gTabWinVirtList.HandleListView
			Else
				If gTabWinAttIns.HandleWinAtt<>0 Then'handle di WinAttention
					SetFocus gTabWinAttIns.HandleWinAtt
				Else
					If gTabWinAttIns.HandleWinIns<>0 Then'handle di WinInsert
						SetFocus gTabWinAttIns.HandleWinIns
					Else
						If gTabWinMsg.HandleWinMsg<>0 Then'handle di WinMessage
							SetFocus gTabWinMsg.HandleWinMsg
						End If
					End If
				End If
			End If
			Function=1
		End If
	END SELECT

END SELECT

End Function

'*******************************************************************************
Function WindoInsert(rOnWinIns As String , rCaptWinIns As String) Export AS LONG
'visualizza la WindoInsert
'IN:rOnWinIns$:da visualizzare sulla WinInsert
'IN:rCaptWinIns$:visualizza sul caption: DebugIx
'OUT:mFunctRes&:OUT:0=error od non creata la dialog; OUT:0 <> handle dialog

Local mFunctRes As Long'OUT:0=error od non creata la dialog; OUT:0 <> handle dialog
Local mLargWinIns As Long
Local mHightWinIns As Long
Local mXbuttonFlowTab As Long
Local mYbuttonFlowTab As Long
Local mLargButtonFlowTab As Long
Local mHightButtonFlowTab As Long


mLargWinIns&=250
mHightWinIns&=70
mXbuttonFlowTab&=195
mYbuttonFlowTab&=55
mLargButtonFlowTab&=30
mHightButtonFlowTab&=10


Dialog Font gFontName$,gFontSize&
	'gFontName$="MS Sans Serif":tipo di font:default=MS Sans Serif
	'gFontSize&=8'size Font:default 8 point

Dialog New %HWND_DESKTOP, rCaptWinIns$, gTabWinAttIns.XLeftUpWinAttIns, gTabWinAttIns.YLeftUpWinAttIns, _
					mLargWinIns&,mHightWinIns&, _
			     %WS_POPUP or %Ws_MiniMizeBox OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CAPTION OR _
              %WS_SYSMENU OR %DS_ABSALIGN OR %DS_3DLOOK OR %DS_SETFONT OR _
              %DS_MODALFRAME OR %DS_NOIDLEMSG, _
              %WS_EX_DLGMODALFRAME OR %WS_EX_CONTROLPARENT OR %WS_EX_WINDOWEDGE To gTabWinAttIns.HandleWinIns

If gTabWinAttIns.HandleWinIns=0 Then
	SeeMessageBox("Error to open WindoInsert","")
	'visualizza il MsgBox
	'IN:rMessageBox$:messaggio da visualizzare
	'IN:rTitleMsgBox$:caption del messaggio da visualizzare

	mFunctRes&=0'0=error od non creata la dialog; OUT:0 <> handle dialog
Else
	mFunctRes&=gTabWinAttIns.HandleWinIns
	CONTROL ADD BUTTON, gTabWinAttIns.HandleWinIns, %ButtonContinue, "Continue", mXbuttonFlowTab&-120, _
				mYbuttonFlowTab, mLargButtonFlowTab&, mHightButtonFlowTab&, %BS_DEFAULT OR %WS_CHILD OR _
				%WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, %WS_EX_NOPARENTNOTIFY

	CONTROL ADD LABEL, gTabWinAttIns.HandleWinIns,  %IDC_WinAtt, rOnWinIns , 1, 1, 215, 75, _
              %WS_CHILD OR %SS_LEFT Or %WS_VISIBLE OR %WS_GROUP OR %SS_NOPREFIX, _
              %WS_EX_NOPARENTNOTIFY

	CONTROL ADD TextBox, gTabWinAttIns.HandleWinIns,  %IDC_WinIns, gInsertVar$ , 1, 40, mLargWinIns&-3, _
					mHightWinIns&-60, %ES_LEFT Or %WS_BORDER Or %WS_TABSTOP

	CONTROL ADD BUTTON, gTabWinAttIns.HandleWinIns, %IDC_FlowTable, "Flow Table", mXbuttonFlowTab&, _
					mYbuttonFlowTab&, mLargButtonFlowTab&+15,	mHightButtonFlowTab&, _
					%BS_DEFAULT OR %WS_CHILD OR %WS_VISIBLE OR %WS_GROUP OR %WS_TABSTOP, %WS_EX_NOPARENTNOTIFY

	Dialog Show Modal gTabWinAttIns.HandleWinIns Call WindoInsertProc


End If

Function=mFunctRes&

End Function

'*******************************************************************************
CallBack Function WindoInsertProc() As LONG

Static mFlowInternal As LONG'0=activate TabFlowInternal(); 1=non activate TabFlowInternal()

SELECT CASE CBMSG
CASE %WM_COMMAND
   SELECT CASE CBCTL
   CASE %ButtonContinue
		IF CBCTLMSG = %BN_CLICKED THEN
			Control Get Text gTabWinAttIns.HandleWinIns, %IDC_WinIns To gInsertVar$
							'variabile caricata/ricavata dalla WinInsert
			DIALOG END CBHNDL, 0
		   gTabWinAttIns.HandleWinIns=0'handle di WinAttention
		End If
		Function=1
	CASE %IDC_FlowTable
		If CBCTLMSG=%BN_CLICKED	Then
			If mFlowInternal&=0 Then'0=activate TabFlowInternal(); 1=non activate TabFlowInternal()
				mFlowInternal&=1
				TabFlowInternal("VariableInsert")
				            'Function di partenza per visualizzare e modificare gTabFlow()
				mFlowInternal&=0
			End If
		End If
		Function=1

	END SELECT

CASE %WM_CTLCOLORBTN, %WM_CTLCOLOREDIT, %WM_CTLCOLORLISTBOX, %WM_CTLCOLORSTATIC
	IF CBLPARAM = GetDlgItem(CBHNDL, %IDC_WinAtt) THEN
		SetBkColor CBWPARAM, GetSysColor(%COLOR_SCROLLBAR)
      FUNCTION = GetStockObject(%NULL_BRUSH)
      EXIT FUNCTION
   ELSEIF CBLPARAM = GetDlgItem(CBHNDL, %ButtonContinue) THEN
      SetBkColor CBWPARAM, GetSysColor(%COLOR_SCROLLBAR)
      FUNCTION = GetStockObject(%NULL_BRUSH)
      EXIT FUNCTION
   END IF

END SELECT

End Function

'*****************************************************************************
Function WindoMessage(rVediRighe As String) Export As Long
'visualizza la Window Message
'IN:rVediRighe$=stringa da visualizzare
'OUT:mFunctRes&:0=error in function out; <>0=handle WinMsg

Static mFirstTime AS Long'indica se e' la 1 volta che viene richiamata questa sub
Local mHndFont 	As Long'indica l'handle del font
Local mLargView 	As Long'larghezza dlle finestra
Local mAltezView 	as Long'altezza delle finestra
Local mFunctRes As Long'0=error in function out; <>0=handle WinMsg

IF mFirstTime&=0 THEN
    'when Function called for the first time, create the Win Message
	mLargView&=gTabWinMsg.LargWinMsg-5
	mAltezView&=gTabWinMsg.HighWinMsg-30
	mFirstTime&=1
	Dialog Font gFontName$,gFontSize&
	'gFontName$="MS Sans Serif":tipo di font:default=MS Sans Serif
	'gFontSize&=8'size Font:default 8 point

   DIALOG NEW 0, "Debug Power Basic:  Window Message"+Space$(40)+"By 60 enne",gTabWinMsg.XLeftUpWinMsg, _
		gTabWinMsg.YLeftUpWinMsg, gTabWinMsg.LargWinMsg, gTabWinMsg.HighWinMsg, %WS_SYSMENU or _
		%Ws_MiniMizeBox TO gTabWinMsg.HandleWinMsg

   CONTROL ADD TEXTBOX, gTabWinMsg.HandleWinMsg, %IDC_WinMsg,  "testo",    0, 0, mLargView&, mAltezView&, _
            %WS_HSCROLL or %WS_VSCROLL OR  %ES_MULTILINE OR %ES_READONLY , %WS_EX_CLIENTEDGE

   CONTROL SET COLOR gTabWinMsg.HandleWinMsg, %IDC_WinMsg, gTabWinMsg.ForeGround, gTabWinMsg.BackGround
   CONTROL SET TEXT gTabWinMsg.HandleWinMsg, %IDC_WinMsg, rVediRighe$

   DIALOG SHOW MODELESS gTabWinMsg.HandleWinMsg

    'create a fixed pitch font
		mHndFont& = CreateFont(17, 0, _         'height, width(default=0)
             0, 0, _                        'escapement, orientation
             %FW_BOLD, _                    'weight
             0, _                           'Italic
             %FALSE, _                      'Underline
             %FALSE, _                      'StrikeThrough
             %ANSI_CHARSET, %OUT_TT_PRECIS, _
             %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
             %FF_SWISS OR %FIXED_PITCH , "")
					 'pitch and family, typeface name "" = first font to match the attributes

	'select font in to the dialog
	CONTROL SEND gTabWinMsg.HandleWinMsg, %IDC_WinMsg, %WM_SETFONT, mHndFont&,-1

END IF

'send resulting text to display
CONTROL SET COLOR gTabWinMsg.HandleWinMsg, %IDC_WinMsg, gTabWinMsg.ForeGround, gTabWinMsg.BackGround
CONTROL SET TEXT gTabWinMsg.HandleWinMsg, %IDC_WinMsg, rVediRighe$

Control Send gTabWinMsg.HandleWinMsg, %IDC_WinMsg, %EM_LINESCROLL, 0, gTabWinMsg.MaxRighe-20
		 'scroll fine schermo

If gTabWinMsg.HandleWinMsg=0 Then
	mFunctRes&=0'0=error in function out; <>0=handle WinMsg
Else
	mFunctRes&=gTabWinMsg.HandleWinMsg
End If

Function=mFunctRes&'0=error in function out; <>0=handle WinMsg

End Function
'*******************************************************************************
function WindoVirtListCtrl(rCaptVirtList As String, rColnHead()As String, rMaxColnHead AS Long) Export As LONG
'visualizza Virtual List Control
'IN:rCaptVirtList$: caption dell Virtual List Control
'IN:rColnHead$(x): "HeadColnFirst, HeadColnSecond, ..."
'				HeadColnX:header (descrizione) della singola colonna; la larghezza di ogni colonna e'
'						impostata come 4*Len(HeadColnX); sono le HeadColnXs che stabiliscono il numero
'						di colonne visibili, ordinabili ed modificabili. HeadColnFirst e' sempre la 1
'						colonna di sx; nella sub/function che richiama DebugVirtListCtrl ci deve essere
'						Dim ColnHead$(0 To n).	Max lunghezza del singolo header=70 caratteri
'				P.S.- 0=HeadColnFirst, 1=HeadColnSecond , ecc.

'IN:rMaxColnHead&:max header delle colonne
'OUT:mHndlDlg&=handle della dialog

local mAsciizBuf   as asciiz * 70
local mListViewCol  as Lv_Column
Local mVirtListLarg As Long'larghezza della virtual list
LOcal mVirtListHigh As Long'hight della virtual list
Local mHndlDlg As DWORD
Local mListViewId As Long'=%Idc_VirtualListView
local mListViewExtStyle  as long
Local mIdxCol As LONG

'..............................................................................................
'inizio Virtual List Control
'crea la Dialog di Virtual List Control

mListViewId&=%Idc_VirtualListView

mVirtListLarg&=gTabWinVirtList.WidthWinVirtList-4'larghezza della virtual list
mVirtListHigh&=gTabWinVirtList.HigthWinVirtList-4'hight della virtual list


Dialog Font gFontName$,gFontSize&
	'gFontName$="MS Sans Serif":tipo di font:default=MS Sans Serif
	'gFontSize&=8'size Font:default 8 point

dialog new  %hwnd_desktop, rCaptVirtList$+Space$(20)+"Esc=End", gTabWinVirtList.XLeftUpWinVirtList, _
			gTabWinVirtList.YLeftUpWinVirtList, gTabWinVirtList.WidthWinVirtList, _
			gTabWinVirtList.HigthWinVirtList, %ws_popup or %ws_border or %ws_dlgframe or %ws_sysmenu _
			 or %Ws_MiniMizeBox Or %ws_clipsiblings or %ws_visible or %ds_modalframe or %ds_3dlook or _
          %ds_nofailcreate or %ds_setfont, %ws_ex_windowedge or _
          %ws_ex_controlparent or %ws_ex_left or %ws_ex_ltrreading or _
          %ws_ex_rightscrollbar, to mHndlDlg???

If mHndlDlg???=0 Then'error
	SeeMessageBox("Error to create Dialog","Function DebugVirtListCtrl")
	'visualizza il MsgBox
	'IN:rMessageBox$:messaggio da visualizzare
	'IN:rTitleMsgBox$:caption del messaggio da visualizzare

	Goto ExitFunctionWindoVirtListCtrl
End If

' create a virtual listview control (add the %lvs_ownerdata style)
control add "syslistview32", mHndlDlg???, %Idc_VirtualListView, "syslistview32_1", _
          2, 2, mVirtListLarg&, mVirtListHigh&, %ws_child or %ws_visible or %ws_border or %lvs_report _
          or %lvs_showselalways or %lvs_ownerdata Or %Lvs_SingleSel, %ws_ex_left or _
          %ws_ex_rightscrollbar or %ws_ex_clientedge or %ws_ex_staticedge
'..............................................................................................


'-----------------------------------------------------------------------------------
' store the virtual listview handle in the global variable
control handle mHndlDlg???, mListViewId& to gTabWinVirtList.HandleListView

' tell the virtual listview control the total items (rows) to show (contained in gListViewArray$()).
ListView_SetItemCount gTabWinVirtList.HandleListView, gTabWinVirtList.TotRow
			'gTabWinVirtList.MaxRow-gTabWinVirtList.MinRow+1

'***********************************
' extend listview
mListViewExtStyle& = ListView_GetExtendedListViewStyle(gTabWinVirtList.HandleListView)
ListView_SetExtendedListViewStyle gTabWinVirtList.HandleListView, mListViewExtStyle&  or _
							%lvs_ex_gridlines or %lvs_ex_fullrowselect


' load column headers.
' first we set the first column
mListViewCol.mask    = %lvcf_width'mListViewCol=Lv_Column=lvcf_width allows adjustment of column width
mListViewCol.fmt     = %lvcfmt_left'mListViewCol=Lv_Column
mListViewCol.psztext = varptr(mAsciizBuf$)'mListViewCol=Lv_Column

mListViewCol.mask    = %lvcf_text or %lvcf_fmt or %lvcf_subitem or %lvcf_width
									  'mListViewCol=Lv_Column

For mIdxCol&=0 To rMaxColnHead&'max header delle colonne
mAsciizBuf$ = rColnHead$(mIdxCol&)'Label column
mListViewCol.cx = Len(rColnHead$(mIdxCol&))*4'width for the column mIdxCol&
											  'mListViewCol=Lv_Column
mListViewCol.iorder  = mIdxCol&'mListViewCol=Lv_Column;offset of column mIdxCol&
listview_insertcolumn gTabWinVirtList.HandleListView, mIdxCol&, mListViewCol'mListViewCol=Lv_Column
				'inserisce la colonna mIdxCol&
Next mIdxCol&

' set focus on virtual list view
control set focus mHndlDlg???,%Idc_VirtualListView

' show it
dialog show modal mHndlDlg???, call WindoVirtListCtrlProc
'fine Virtual List Control
'..............................................................................................

ExitFunctionWindoVirtListCtrl:
Function=mHndlDlg???'handle della dialog DebugVirtListCntrl

End Function

'*****************************************************************************
callback function WindoVirtListCtrlProc()


local mPtrNmListView   as NmListView ptr
local mPtrNmLvDispInfo as NmLvDispInfo ptr
local mAscizBuf		   as asciiz * 128
local mPtrLvKeyDown    as lv_keydown ptr
local mCellText  as asciiz * 50
Local mTempArray() As STRING

select case as long cbmsg
case %wm_command

   ' process control notifications
   select case as long cbctl
         ' trapping the enter key (%idok)

   case %idok

      ' gTabWinVirtList.HandleListView is the virtual listview control handle for this program
      ' test if the listview has the focus
      if GetFocus = gTabWinVirtList.HandleListView then

      end if


   case %idcancel       ' esc key  of dialog
		If gTabWinVirtList.SortOut>-1 Then'contiene la colonna sulla quale effettuare sort in uscita della function:
					'-1=nessuna sort in uscita; 0<= X <= n effetuare il sort in uscita sulla colonna x
			if gTabWinVirtList.DirectSortOut=1 Then
					'sort direzione 1=ascendente/0=discendente della colonna indicata da gTabWinVirtList.SortOut
				gTabWinVirtList.LvSort =1'gTabWinVirtList.LvSort:0=sort discendente; 1=sort ascendente
			Else
				gTabWinVirtList.LvSort =0'gTabWinVirtList.LvSort:0=sort discendente; 1=sort ascendente
			End If
			DebugVirtListSort  gTabWinVirtList.SortOut 'sort sulla colonna indicata
			'sort di gListViewArray$() alla colonna rColumnForSort&
			'IN:gListViewArray$()=joining(Join$) in un solo campo di rListArrayIn$() della Function DebugVirtListCtrl
			'IN:rColumnForSort&=colonna su cui fare sort
			'IN:gTabWinVirtList.LvSort:0=sort discendente; 1=sort ascendente

		End If

      dialog end cbhndl
		gTabWinVirtList.HandleListView=0' virtual listview control handle

   case %Idc_VirtualListView
      ' pbforms puts this message trap here. i have not needed to figure it out (yet).

   End select

case %wm_notify

   ' the wm_notify message informs the parent window of a control that an event has
   ' occurred in the control or that the control requires some kind of information.


   ' handle listview notifications only
   if lowrd(cbwparam) <> %Idc_VirtualListView then
		exit select
	End If

   ' obtain the NmListView pointer from cblparam
   mPtrNmListView = cblparam

   ' obtain the lv_keydown pointer from cblparam
   mPtrLvKeyDown = cblparam

   select case @mPtrNmListView.hdr.code
   case %lvn_getdispinfo

      ' obtain the NmLvDispInfo pointer from cblparam
      mPtrNmLvDispInfo = cblparam


      'virtual listview asks for item text;richiede tutte le row da visualizzare
      if (@mPtrNmLvDispInfo.item.mask and %lvif_text) then
         mAscizBuf$ = parse$(gListViewArray$(@mPtrNmLvDispInfo.item.iitem), $tab, _
														@mPtrNmLvDispInfo.item.isubitem + 1)
				'gListViewArray$()=joining(Join$) in un solo campo di rListArrayIn$() della Function DebugVirtListCtrl
         @mPtrNmLvDispInfo.item.psztext = varptr(mAscizBuf$)
      end if

   case %lvn_columnclick      ' click on column header to sort

      if @mPtrNmListView.isubitem <> -1& then
			If gGestClmnVirtList(@mPtrNmListView.isubitem ).SortColumn=1 Then
							'0=no sort sulla corrispondente colonna; 1=si sort sulla corrispondente colonna
				DebugVirtListSort @mPtrNmListView.isubitem
				'sort di gListViewArray$() alla colonna rColumnForSort&
				'IN:gListViewArray$()=joining(Join$) in un solo campo di rListArrayIn$() della Function DebugVirtListCtrl
				'IN:rColumnForSort&=colonna su cui fare sort
				'IN:gTabWinVirtList.LvSort:0=sort discendente; 1=sort ascendente

				' redraw listview
				InvalidateRect gTabWinVirtList.HandleListView, byval %null, 0
				UpdateWindow gTabWinVirtList.HandleListView
			End If
      end if

   case %nm_click


   case %nm_dblclk

         'to get the text in the cell use the following code
         listview_getitemtext (byval gTabWinVirtList.HandleListView, byval @mPtrNmListView.iitem, _
                                  byval @mPtrNmListView.isubitem, mCellText$, sizeof (mCellText$))
			If gGestClmnVirtList(@mPtrNmListView.isubitem).ModifyColumn=1 Then
						'isubitem=colonna; inizia da colonna 0
						'iitem=row;inizia da row 0
				Redim mTempArray(gTabWinVirtList.MinCol+gTabWinVirtList.DeltaCol To gTabWinVirtList.MaxCol+ _
									gTabWinVirtList.DeltaCol) As STRING
				Parse gListViewArray$(@mPtrNmListView.iitem),mTempArray$(), $Tab
				mTempArray$(@mPtrNmListView.isubitem)=InputBox$($CrLf+gListViewColnHelp$(@mPtrNmListView.isubitem), _
				 "Row:"+Str$(@mPtrNmListView.iitem+1)+"   Col.(0 to x):"+Str$(@mPtrNmListView.isubitem), _
							mTempArray$(@mPtrNmListView.isubitem))
				gListViewArray$(@mPtrNmListView.iitem)=Join$(mTempArray(),$Tab)

				InvalidateRect gTabWinVirtList.HandleListView, byval %null, 0
				UpdateWindow gTabWinVirtList.HandleListView

			End If

			control set focus cbhndl, %Idc_VirtualListView' reset the focus on the listview again

   case  %lvn_keydown  ' processes every key except enter(ok) and esc (cancel)

			' we check for system keys that do not affect the selection bar in the listview
      ' control and let then pass through. everything else we filter it out.

      if @mPtrLvKeyDown.wvkey >= %vk_lbutton and @mPtrLvKeyDown.wvkey =< %vk_help then
			function = %false : exit select
		End If
      if @mPtrLvKeyDown.wvkey >= %vk_lwin and @mPtrLvKeyDown.wvkey =< %vk_sleep then
			function = %false : exit select
		End If

      ' no more key press processing by the os
      function = %true

   end select

end select

end function

